> This page is for Developers.

> For clean Markdown of any page, append .md to the page URL.
> For a complete documentation index, see https://zuora.ferndocs.com/llms.txt.
> For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://zuora.ferndocs.com/_mcp/server.

# Regenerate booking transactions

POST https://rest.test.zuora.com/v1/uno-regenerate/booking-transaction
Content-Type: application/json

Use this operation to generate booking transactions. This call is useful in the following two use cases:
* During customer onboarding, there is a common scenario when customers perform data backfill or data fixes. To synchronize these changes from Billing to Revenue, use this API operation to regenerate booking transaction objects.
* Customers choose to experiment with their use cases in the Sandbox environment before implementing them in the Production environment. During this experimentation phase, customers not only interact with data but also use this API operation to regenerate booking transaction objects.


Reference: https://zuora.ferndocs.com/developers/api-reference/zuora-api/order-to-revenue/regenerate/post-regenerate-booking-transaction

## Authentication

- `Authorization` header (bearer token, required) — Use `Bearer {{token}}` in the `Authorization` header for authentication.

## Servers

- `https://rest.test.zuora.com` (US Developer & Central Sandbox (incl. Test Drive), default)
- `https://rest.sandbox.na.zuora.com` (US API Sandbox Cloud 1)
- `https://rest.apisandbox.zuora.com` (US API Sandbox Cloud 2)
- `https://rest.na.zuora.com` (US Production Cloud 1)
- `https://rest.zuora.com` (US Production Cloud 2)
- `https://rest.test.eu.zuora.com` (EU Developer & Central Sandbox)
- `https://rest.sandbox.eu.zuora.com` (EU API Sandbox)
- `https://rest.eu.zuora.com` (EU Production)
- `https://rest.test.ap.zuora.com` (APAC Developer & Central Sandbox)
- `https://rest.ap.zuora.com` (APAC Production)

## Request

### Query parameters

- `onlyReSend` (boolean, optional) — If `onlyReSend` is true, existing booking transactions in the database will not be overridden and sent into Revenue for re-collecting, i.e. regenerate_flag is Y. If `onlyReSend` is false, existing booking transactions in the database will be overridden and sent into Revenue, no matter what is the value of `reMigrate`. **Note:** If `onlyReSend` is true, the `reMigrate` can't be true.
- `reMigrate` (boolean, optional) — If `reMigrate` is true, existing booking transactions in the database will be overridden and sent into Revenue for re-collecting, i.e. regenerate_flag is Y. If `reMigrate` is false, existing booking transactions in the database will be overridden and sent into Revenue with regenerate_flag as N. **Note:** If `onlyReSend` is true, the `reMigrate` can't be true.

### Headers

- `Idempotency-Key` (string, optional) — Specify a unique idempotency key if you want to perform an idempotent POST or PATCH request. Do not use this header in other request types. With this header specified, the Zuora server can identify subsequent retries of the same request using this value, which prevents the same operation from being performed multiple times by accident.
- `Accept-Encoding` (string, optional) — Include the `Accept-Encoding: gzip` header to compress responses as a gzipped file. It can significantly reduce the bandwidth required for a response. If specified, Zuora automatically compresses responses that contain over 1000 bytes of data, and the response contains a `Content-Encoding` header with the compression algorithm so that your client can decompress it.
- `Content-Encoding` (string, optional) — Include the `Content-Encoding: gzip` header to compress a request. With this header specified, you should upload a gzipped file for the request payload instead of sending the JSON payload.
- `Zuora-Track-Id` (string, optional) — A custom identifier for tracing the API call. If you set a value for this header, Zuora returns the same value in the response headers. This header enables you to associate your system process identifiers with Zuora API calls, to assist with troubleshooting in the event of an issue. The value of this field must use the US-ASCII character set and must not include any of the following characters: colon (`:`), semicolon (`;`), double quote (`"`), and quote (`'`).
- `Zuora-Entity-Ids` (string, optional) — An entity ID. If you have [Zuora Multi-entity](https://knowledgecenter.zuora.com/BB_Introducing_Z_Business/Multi-entity) enabled and the OAuth token is valid for more than one entity, you must use this header to specify which entity to perform the operation in. If the OAuth token is only valid for a single entity, or you do not have Zuora Multi-entity enabled, you should not set this header.
- `Zuora-Org-Ids` (string, optional) — Comma separated IDs. If you have Zuora Multi-Org enabled, you can use this header to specify which orgs to perform the operation in. If you do not have Zuora Multi-Org enabled, you should not set this header. The IDs must be a sub-set of the user's accessible orgs. If you specify an org that the user does not have access to, the operation fails. This header is important in Multi-Org (MO) setups because it defines the organization context under which the API should operate—mainly used for read access or data visibility filtering. If the header is not set, the operation is performed in scope of the user's accessible orgs.
- `Zuora-Version` (string, optional) — The minor API version. For a list of available minor versions, see [API upgrades](https://developer.zuora.com/v1-api-reference/api-upgrades/).

### Body (application/json)

This endpoint expects a RegenerateBookingRequest.

- `itemNumber` (string, optional) — The item number.
- `orderLineItemId` (string, optional) — The order line item ID.
- `orderNumber` (string, optional) — The order number.
- `subscriptionId` (string, optional) — The subscription ID.
- `subscriptionName` (string, optional) — The subscription name.
- `subscriptionVersion` (integer, optional) — The subscription version.
- `ratePlanChargeId` (string, optional) — The rate plan charge ID of dynamic usage charge.
- `chargeNumber` (string, optional) — The charge number of dynamic usage charge.
- `type` (enum, optional) — The type of business object for which you want to generate the transactions.
  - Allowed values: `Subscription`, `OrderLineItem`, `DynamicUsageCharge`

## Response

### 200

OK

- `idList` (list of string, optional) — A list of the IDs for the business objects for which you generate the transactions.
- `reasons` (list of ResponseReasons, optional)
- `success` (boolean, optional) — Indicates whether the call succeeded.

## Errors

### 500 Internal Server Error

Internal Server Error

- `reasons` (list of ErrorResponseReasonsItems, optional)

### 400 Client Request Error

Request Errors

- `processId` (string, optional) — The ID of the process that handles the operation.
- `reasons` (list of CommonResponseReasonsItems, optional) — The container of the error code and message. This field is available only if the `success` field is `false`.
- `requestId` (string, optional) — Unique identifier of the request.
- `success` (boolean, optional) — Indicates whether the call succeeded.

## Types

### ResponseReasons

- `code` (string, optional) — The error code of response.
- `message` (string, optional) — The detail information of the error response.

### ErrorResponseReasonsItems

- `code` (string, optional) — The error code of response.
- `message` (string, optional) — The detail information of the error response

### CommonResponseReasonsItems

- `code` (string, optional) — The error code of response.
- `message` (string, optional) — The detail information of the error response

## Examples

**Request**

```json
{
  "subscriptionName": "A-S00000001",
  "subscriptionVersion": 1,
  "type": "Subscription"
}
```

**Response**

```json
{
  "idList": [
    "2c9890508ad035db018ad0d8d1685fef",
    "2c9890508ad035db018ad0d8d4ec6013"
  ],
  "success": true
}
```

**SDK Code**

```python response
import requests

url = "https://rest.test.zuora.com/v1/uno-regenerate/booking-transaction"

payload = {
    "subscriptionName": "A-S00000001",
    "subscriptionVersion": 1,
    "type": "Subscription"
}
headers = {
    "Authorization": "Bearer <token>",
    "Content-Type": "application/json"
}

response = requests.post(url, json=payload, headers=headers)

print(response.json())
```

```javascript response
const url = 'https://rest.test.zuora.com/v1/uno-regenerate/booking-transaction';
const options = {
  method: 'POST',
  headers: {Authorization: 'Bearer <token>', 'Content-Type': 'application/json'},
  body: '{"subscriptionName":"A-S00000001","subscriptionVersion":1,"type":"Subscription"}'
};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go response
package main

import (
	"fmt"
	"strings"
	"net/http"
	"io"
)

func main() {

	url := "https://rest.test.zuora.com/v1/uno-regenerate/booking-transaction"

	payload := strings.NewReader("{\n  \"subscriptionName\": \"A-S00000001\",\n  \"subscriptionVersion\": 1,\n  \"type\": \"Subscription\"\n}")

	req, _ := http.NewRequest("POST", url, payload)

	req.Header.Add("Authorization", "Bearer <token>")
	req.Header.Add("Content-Type", "application/json")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby response
require 'uri'
require 'net/http'

url = URI("https://rest.test.zuora.com/v1/uno-regenerate/booking-transaction")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Post.new(url)
request["Authorization"] = 'Bearer <token>'
request["Content-Type"] = 'application/json'
request.body = "{\n  \"subscriptionName\": \"A-S00000001\",\n  \"subscriptionVersion\": 1,\n  \"type\": \"Subscription\"\n}"

response = http.request(request)
puts response.read_body
```

```java response
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.post("https://rest.test.zuora.com/v1/uno-regenerate/booking-transaction")
  .header("Authorization", "Bearer <token>")
  .header("Content-Type", "application/json")
  .body("{\n  \"subscriptionName\": \"A-S00000001\",\n  \"subscriptionVersion\": 1,\n  \"type\": \"Subscription\"\n}")
  .asString();
```

```php response
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('POST', 'https://rest.test.zuora.com/v1/uno-regenerate/booking-transaction', [
  'body' => '{
  "subscriptionName": "A-S00000001",
  "subscriptionVersion": 1,
  "type": "Subscription"
}',
  'headers' => [
    'Authorization' => 'Bearer <token>',
    'Content-Type' => 'application/json',
  ],
]);

echo $response->getBody();
```

```csharp response
using RestSharp;

var client = new RestClient("https://rest.test.zuora.com/v1/uno-regenerate/booking-transaction");
var request = new RestRequest(Method.POST);
request.AddHeader("Authorization", "Bearer <token>");
request.AddHeader("Content-Type", "application/json");
request.AddParameter("application/json", "{\n  \"subscriptionName\": \"A-S00000001\",\n  \"subscriptionVersion\": 1,\n  \"type\": \"Subscription\"\n}", ParameterType.RequestBody);
IRestResponse response = client.Execute(request);
```

```swift response
import Foundation

let headers = [
  "Authorization": "Bearer <token>",
  "Content-Type": "application/json"
]
let parameters = [
  "subscriptionName": "A-S00000001",
  "subscriptionVersion": 1,
  "type": "Subscription"
] as [String : Any]

let postData = JSONSerialization.data(withJSONObject: parameters, options: [])

let request = NSMutableURLRequest(url: NSURL(string: "https://rest.test.zuora.com/v1/uno-regenerate/booking-transaction")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "POST"
request.allHTTPHeaderFields = headers
request.httpBody = postData as Data

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```